# upstream-api-client
Sensor Storage for Upstream data

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 0.1.0
- Generator version: 7.14.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/In-For-Disaster-Analytics/upstream-python-api-client.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/In-For-Disaster-Analytics/upstream-python-api-client.git`)

Then import the package:
```python
import upstream_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import upstream_api_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import upstream_api_client
from upstream_api_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to /dev
# See configuration.py for a list of all supported configuration parameters.
configuration = upstream_api_client.Configuration(
    host = "/dev"
)



# Enter a context with an instance of the API client
with upstream_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = upstream_api_client.AuthApi(api_client)
    username = 'username_example' # str | 
    password = 'password_example' # str | 
    grant_type = 'grant_type_example' # str |  (optional)
    scope = '' # str |  (optional) (default to '')
    client_id = 'client_id_example' # str |  (optional)
    client_secret = 'client_secret_example' # str |  (optional)

    try:
        # Login
        api_response = api_instance.login_api_v1_token_post(username, password, grant_type=grant_type, scope=scope, client_id=client_id, client_secret=client_secret)
        print("The response of AuthApi->login_api_v1_token_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AuthApi->login_api_v1_token_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to */dev*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**login_api_v1_token_post**](docs/AuthApi.md#login_api_v1_token_post) | **POST** /api/v1/token | Login
*CampaignsApi* | [**create_campaign_api_v1_campaigns_post**](docs/CampaignsApi.md#create_campaign_api_v1_campaigns_post) | **POST** /api/v1/campaigns | Create Campaign
*CampaignsApi* | [**delete_sensor_api_v1_campaigns_campaign_id_delete**](docs/CampaignsApi.md#delete_sensor_api_v1_campaigns_campaign_id_delete) | **DELETE** /api/v1/campaigns/{campaign_id} | Delete Sensor
*CampaignsApi* | [**get_campaign_api_v1_campaigns_campaign_id_get**](docs/CampaignsApi.md#get_campaign_api_v1_campaigns_campaign_id_get) | **GET** /api/v1/campaigns/{campaign_id} | Get Campaign
*CampaignsApi* | [**list_campaigns_api_v1_campaigns_get**](docs/CampaignsApi.md#list_campaigns_api_v1_campaigns_get) | **GET** /api/v1/campaigns | List Campaigns
*CampaignsApi* | [**partial_update_campaign_api_v1_campaigns_campaign_id_patch**](docs/CampaignsApi.md#partial_update_campaign_api_v1_campaigns_campaign_id_patch) | **PATCH** /api/v1/campaigns/{campaign_id} | Partial Update Campaign
*CampaignsApi* | [**update_campaign_api_v1_campaigns_campaign_id_put**](docs/CampaignsApi.md#update_campaign_api_v1_campaigns_campaign_id_put) | **PUT** /api/v1/campaigns/{campaign_id} | Update Campaign
*MeasurementsApi* | [**create_measurement_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_post**](docs/MeasurementsApi.md#create_measurement_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_post) | **POST** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements | Create Measurement
*MeasurementsApi* | [**delete_sensor_measurements_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_delete**](docs/MeasurementsApi.md#delete_sensor_measurements_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_delete) | **DELETE** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements | Delete Sensor Measurements
*MeasurementsApi* | [**get_measurements_with_confidence_intervals_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_confidence_intervals_get**](docs/MeasurementsApi.md#get_measurements_with_confidence_intervals_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_confidence_intervals_get) | **GET** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements/confidence-intervals | Get Measurements With Confidence Intervals
*MeasurementsApi* | [**get_sensor_measurements_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_get**](docs/MeasurementsApi.md#get_sensor_measurements_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_get) | **GET** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements | Get Sensor Measurements
*MeasurementsApi* | [**partial_update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_measurement_id_patch**](docs/MeasurementsApi.md#partial_update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_measurement_id_patch) | **PATCH** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements/{measurement_id} | Partial Update Sensor
*MeasurementsApi* | [**update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_measurement_id_put**](docs/MeasurementsApi.md#update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_measurements_measurement_id_put) | **PUT** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id}/measurements/{measurement_id} | Update Sensor
*ProjectsApi* | [**get_project_members_for_user_api_v1_projects_project_id_members_get**](docs/ProjectsApi.md#get_project_members_for_user_api_v1_projects_project_id_members_get) | **GET** /api/v1/projects/{project_id}/members | Get Project Members For User
*ProjectsApi* | [**get_projects_api_v1_projects_get**](docs/ProjectsApi.md#get_projects_api_v1_projects_get) | **GET** /api/v1/projects | Get Projects
*SensorVariablesApi* | [**list_sensor_variables_api_v1_sensor_variables_get**](docs/SensorVariablesApi.md#list_sensor_variables_api_v1_sensor_variables_get) | **GET** /api/v1/sensor_variables | List Sensor Variables
*SensorsApi* | [**delete_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_delete**](docs/SensorsApi.md#delete_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_delete) | **DELETE** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors | Delete Sensor
*SensorsApi* | [**get_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_get**](docs/SensorsApi.md#get_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_get) | **GET** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id} | Get Sensor
*SensorsApi* | [**list_sensors_api_v1_campaigns_campaign_id_stations_station_id_sensors_get**](docs/SensorsApi.md#list_sensors_api_v1_campaigns_campaign_id_stations_station_id_sensors_get) | **GET** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors | List Sensors
*SensorsApi* | [**partial_update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_patch**](docs/SensorsApi.md#partial_update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_patch) | **PATCH** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id} | Partial Update Sensor
*SensorsApi* | [**update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_put**](docs/SensorsApi.md#update_sensor_api_v1_campaigns_campaign_id_stations_station_id_sensors_sensor_id_put) | **PUT** /api/v1/campaigns/{campaign_id}/stations/{station_id}/sensors/{sensor_id} | Update Sensor
*StationsApi* | [**create_station_api_v1_campaigns_campaign_id_stations_post**](docs/StationsApi.md#create_station_api_v1_campaigns_campaign_id_stations_post) | **POST** /api/v1/campaigns/{campaign_id}/stations | Create Station
*StationsApi* | [**delete_sensor_api_v1_campaigns_campaign_id_stations_delete**](docs/StationsApi.md#delete_sensor_api_v1_campaigns_campaign_id_stations_delete) | **DELETE** /api/v1/campaigns/{campaign_id}/stations | Delete Sensor
*StationsApi* | [**get_station_api_v1_campaigns_campaign_id_stations_station_id_get**](docs/StationsApi.md#get_station_api_v1_campaigns_campaign_id_stations_station_id_get) | **GET** /api/v1/campaigns/{campaign_id}/stations/{station_id} | Get Station
*StationsApi* | [**list_stations_api_v1_campaigns_campaign_id_stations_get**](docs/StationsApi.md#list_stations_api_v1_campaigns_campaign_id_stations_get) | **GET** /api/v1/campaigns/{campaign_id}/stations | List Stations
*StationsApi* | [**partial_update_station_api_v1_campaigns_campaign_id_stations_station_id_patch**](docs/StationsApi.md#partial_update_station_api_v1_campaigns_campaign_id_stations_station_id_patch) | **PATCH** /api/v1/campaigns/{campaign_id}/stations/{station_id} | Partial Update Station
*StationsApi* | [**update_station_api_v1_campaigns_campaign_id_stations_station_id_put**](docs/StationsApi.md#update_station_api_v1_campaigns_campaign_id_stations_station_id_put) | **PUT** /api/v1/campaigns/{campaign_id}/stations/{station_id} | Update Station
*UploadfileCsvApi* | [**post_sensor_and_measurement_api_v1_uploadfile_csv_campaign_campaign_id_station_station_id_sensor_post**](docs/UploadfileCsvApi.md#post_sensor_and_measurement_api_v1_uploadfile_csv_campaign_campaign_id_station_station_id_sensor_post) | **POST** /api/v1/uploadfile_csv/campaign/{campaign_id}/station/{station_id}/sensor | Post Sensor And Measurement


## Documentation For Models

 - [AggregatedMeasurement](docs/AggregatedMeasurement.md)
 - [Bbox](docs/Bbox.md)
 - [CampaignCreateResponse](docs/CampaignCreateResponse.md)
 - [CampaignUpdate](docs/CampaignUpdate.md)
 - [CampaignsIn](docs/CampaignsIn.md)
 - [Coordinates](docs/Coordinates.md)
 - [GeometryCollection](docs/GeometryCollection.md)
 - [GeometryCollectionGeometriesInner](docs/GeometryCollectionGeometriesInner.md)
 - [GetCampaignResponse](docs/GetCampaignResponse.md)
 - [GetCampaignResponseGeometry](docs/GetCampaignResponseGeometry.md)
 - [GetSensorResponse](docs/GetSensorResponse.md)
 - [GetStationResponse](docs/GetStationResponse.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [LineString](docs/LineString.md)
 - [LineStringCoordinatesInner](docs/LineStringCoordinatesInner.md)
 - [ListCampaignsResponseItem](docs/ListCampaignsResponseItem.md)
 - [ListCampaignsResponsePagination](docs/ListCampaignsResponsePagination.md)
 - [ListMeasurementsResponsePagination](docs/ListMeasurementsResponsePagination.md)
 - [ListSensorsResponsePagination](docs/ListSensorsResponsePagination.md)
 - [ListStationsResponsePagination](docs/ListStationsResponsePagination.md)
 - [Location](docs/Location.md)
 - [MeasurementCreateResponse](docs/MeasurementCreateResponse.md)
 - [MeasurementIn](docs/MeasurementIn.md)
 - [MeasurementItem](docs/MeasurementItem.md)
 - [MeasurementUpdate](docs/MeasurementUpdate.md)
 - [MultiLineString](docs/MultiLineString.md)
 - [MultiPoint](docs/MultiPoint.md)
 - [MultiPolygon](docs/MultiPolygon.md)
 - [Point](docs/Point.md)
 - [Polygon](docs/Polygon.md)
 - [PyTASAllocation](docs/PyTASAllocation.md)
 - [PyTASPi](docs/PyTASPi.md)
 - [PyTASProject](docs/PyTASProject.md)
 - [PyTASUser](docs/PyTASUser.md)
 - [ResponseLoginApiV1TokenPost](docs/ResponseLoginApiV1TokenPost.md)
 - [SensorCreateResponse](docs/SensorCreateResponse.md)
 - [SensorItem](docs/SensorItem.md)
 - [SensorStatistics](docs/SensorStatistics.md)
 - [SensorSummaryForStations](docs/SensorSummaryForStations.md)
 - [SensorUpdate](docs/SensorUpdate.md)
 - [SortField](docs/SortField.md)
 - [StationCreate](docs/StationCreate.md)
 - [StationCreateResponse](docs/StationCreateResponse.md)
 - [StationItemWithSummary](docs/StationItemWithSummary.md)
 - [StationType](docs/StationType.md)
 - [StationUpdate](docs/StationUpdate.md)
 - [StationsListResponseItem](docs/StationsListResponseItem.md)
 - [SummaryGetCampaign](docs/SummaryGetCampaign.md)
 - [SummaryListCampaigns](docs/SummaryListCampaigns.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="OAuth2PasswordBearer"></a>
### OAuth2PasswordBearer

- **Type**: OAuth
- **Flow**: password
- **Authorization URL**: 
- **Scopes**: N/A


## Author

wmobley@tacc.utexas.edu


