# coding: utf-8

# flake8: noqa

"""
    Upstream Sensor Storage

    Sensor Storage for Upstream data

    The version of the OpenAPI document: 0.0.1
    Contact: wmobley@tacc.utexas.edu
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "0.1.0"

# Define package exports
__all__ = [
    "AuthApi",
    "CampaignsApi",
    "MeasurementsApi",
    "ProjectsApi",
    "SensorVariablesApi",
    "SensorsApi",
    "StationsApi",
    "UploadfileCsvApi",
    "ApiResponse",
    "ApiClient",
    "Configuration",
    "OpenApiException",
    "ApiTypeError",
    "ApiValueError",
    "ApiKeyError",
    "ApiAttributeError",
    "ApiException",
    "AggregatedMeasurement",
    "Bbox",
    "CampaignCreateResponse",
    "CampaignUpdate",
    "CampaignsIn",
    "Coordinates",
    "GeometryCollection",
    "GeometryCollectionGeometriesInner",
    "GetCampaignResponse",
    "GetCampaignResponseGeometry",
    "GetSensorResponse",
    "GetStationResponse",
    "HTTPValidationError",
    "LineString",
    "LineStringCoordinatesInner",
    "ListCampaignsResponseItem",
    "ListCampaignsResponsePagination",
    "ListMeasurementsResponsePagination",
    "ListSensorsResponsePagination",
    "ListStationsResponsePagination",
    "Location",
    "MeasurementCreateResponse",
    "MeasurementIn",
    "MeasurementItem",
    "MeasurementUpdate",
    "MultiLineString",
    "MultiPoint",
    "MultiPolygon",
    "Point",
    "Polygon",
    "PyTASAllocation",
    "PyTASPi",
    "PyTASProject",
    "PyTASUser",
    "ResponseLoginApiV1TokenPost",
    "SensorCreateResponse",
    "SensorItem",
    "SensorStatistics",
    "SensorSummaryForStations",
    "SensorUpdate",
    "SortField",
    "StationCreate",
    "StationCreateResponse",
    "StationItemWithSummary",
    "StationType",
    "StationUpdate",
    "StationsListResponseItem",
    "SummaryGetCampaign",
    "SummaryListCampaigns",
    "ValidationError",
    "ValidationErrorLocInner",
]

# import apis into sdk package
from upstream_api_client.api.auth_api import AuthApi as AuthApi
from upstream_api_client.api.campaigns_api import CampaignsApi as CampaignsApi
from upstream_api_client.api.measurements_api import MeasurementsApi as MeasurementsApi
from upstream_api_client.api.projects_api import ProjectsApi as ProjectsApi
from upstream_api_client.api.sensor_variables_api import SensorVariablesApi as SensorVariablesApi
from upstream_api_client.api.sensors_api import SensorsApi as SensorsApi
from upstream_api_client.api.stations_api import StationsApi as StationsApi
from upstream_api_client.api.uploadfile_csv_api import UploadfileCsvApi as UploadfileCsvApi

# import ApiClient
from upstream_api_client.api_response import ApiResponse as ApiResponse
from upstream_api_client.api_client import ApiClient as ApiClient
from upstream_api_client.configuration import Configuration as Configuration
from upstream_api_client.exceptions import OpenApiException as OpenApiException
from upstream_api_client.exceptions import ApiTypeError as ApiTypeError
from upstream_api_client.exceptions import ApiValueError as ApiValueError
from upstream_api_client.exceptions import ApiKeyError as ApiKeyError
from upstream_api_client.exceptions import ApiAttributeError as ApiAttributeError
from upstream_api_client.exceptions import ApiException as ApiException

# import models into sdk package
from upstream_api_client.models.aggregated_measurement import AggregatedMeasurement as AggregatedMeasurement
from upstream_api_client.models.bbox import Bbox as Bbox
from upstream_api_client.models.campaign_create_response import CampaignCreateResponse as CampaignCreateResponse
from upstream_api_client.models.campaign_update import CampaignUpdate as CampaignUpdate
from upstream_api_client.models.campaigns_in import CampaignsIn as CampaignsIn
from upstream_api_client.models.coordinates import Coordinates as Coordinates
from upstream_api_client.models.geometry_collection import GeometryCollection as GeometryCollection
from upstream_api_client.models.geometry_collection_geometries_inner import GeometryCollectionGeometriesInner as GeometryCollectionGeometriesInner
from upstream_api_client.models.get_campaign_response import GetCampaignResponse as GetCampaignResponse
from upstream_api_client.models.get_campaign_response_geometry import GetCampaignResponseGeometry as GetCampaignResponseGeometry
from upstream_api_client.models.get_sensor_response import GetSensorResponse as GetSensorResponse
from upstream_api_client.models.get_station_response import GetStationResponse as GetStationResponse
from upstream_api_client.models.http_validation_error import HTTPValidationError as HTTPValidationError
from upstream_api_client.models.line_string import LineString as LineString
from upstream_api_client.models.line_string_coordinates_inner import LineStringCoordinatesInner as LineStringCoordinatesInner
from upstream_api_client.models.list_campaigns_response_item import ListCampaignsResponseItem as ListCampaignsResponseItem
from upstream_api_client.models.list_campaigns_response_pagination import ListCampaignsResponsePagination as ListCampaignsResponsePagination
from upstream_api_client.models.list_measurements_response_pagination import ListMeasurementsResponsePagination as ListMeasurementsResponsePagination
from upstream_api_client.models.list_sensors_response_pagination import ListSensorsResponsePagination as ListSensorsResponsePagination
from upstream_api_client.models.list_stations_response_pagination import ListStationsResponsePagination as ListStationsResponsePagination
from upstream_api_client.models.location import Location as Location
from upstream_api_client.models.measurement_create_response import MeasurementCreateResponse as MeasurementCreateResponse
from upstream_api_client.models.measurement_in import MeasurementIn as MeasurementIn
from upstream_api_client.models.measurement_item import MeasurementItem as MeasurementItem
from upstream_api_client.models.measurement_update import MeasurementUpdate as MeasurementUpdate
from upstream_api_client.models.multi_line_string import MultiLineString as MultiLineString
from upstream_api_client.models.multi_point import MultiPoint as MultiPoint
from upstream_api_client.models.multi_polygon import MultiPolygon as MultiPolygon
from upstream_api_client.models.point import Point as Point
from upstream_api_client.models.polygon import Polygon as Polygon
from upstream_api_client.models.py_tas_allocation import PyTASAllocation as PyTASAllocation
from upstream_api_client.models.py_taspi import PyTASPi as PyTASPi
from upstream_api_client.models.py_tas_project import PyTASProject as PyTASProject
from upstream_api_client.models.py_tas_user import PyTASUser as PyTASUser
from upstream_api_client.models.response_login_api_v1_token_post import ResponseLoginApiV1TokenPost as ResponseLoginApiV1TokenPost
from upstream_api_client.models.sensor_create_response import SensorCreateResponse as SensorCreateResponse
from upstream_api_client.models.sensor_item import SensorItem as SensorItem
from upstream_api_client.models.sensor_statistics import SensorStatistics as SensorStatistics
from upstream_api_client.models.sensor_summary_for_stations import SensorSummaryForStations as SensorSummaryForStations
from upstream_api_client.models.sensor_update import SensorUpdate as SensorUpdate
from upstream_api_client.models.sort_field import SortField as SortField
from upstream_api_client.models.station_create import StationCreate as StationCreate
from upstream_api_client.models.station_create_response import StationCreateResponse as StationCreateResponse
from upstream_api_client.models.station_item_with_summary import StationItemWithSummary as StationItemWithSummary
from upstream_api_client.models.station_type import StationType as StationType
from upstream_api_client.models.station_update import StationUpdate as StationUpdate
from upstream_api_client.models.stations_list_response_item import StationsListResponseItem as StationsListResponseItem
from upstream_api_client.models.summary_get_campaign import SummaryGetCampaign as SummaryGetCampaign
from upstream_api_client.models.summary_list_campaigns import SummaryListCampaigns as SummaryListCampaigns
from upstream_api_client.models.validation_error import ValidationError as ValidationError
from upstream_api_client.models.validation_error_loc_inner import ValidationErrorLocInner as ValidationErrorLocInner
