# coding: utf-8

"""
    Upstream Sensor Storage

    Sensor Storage for Upstream data

    The version of the OpenAPI document: 0.0.1
    Contact: wmobley@tacc.utexas.edu
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from upstream_api_client.models.get_campaign_response_geometry import GetCampaignResponseGeometry
from upstream_api_client.models.location import Location
from upstream_api_client.models.stations_list_response_item import StationsListResponseItem
from upstream_api_client.models.summary_get_campaign import SummaryGetCampaign
from typing import Optional, Set
from typing_extensions import Self

class GetCampaignResponse(BaseModel):
    """
    GetCampaignResponse
    """ # noqa: E501
    id: StrictInt
    name: StrictStr
    description: Optional[StrictStr] = None
    contact_name: Optional[StrictStr] = None
    contact_email: Optional[StrictStr] = None
    start_date: Optional[datetime] = None
    end_date: Optional[datetime] = None
    allocation: StrictStr
    location: Optional[Location] = None
    summary: SummaryGetCampaign
    geometry: Optional[GetCampaignResponseGeometry] = None
    stations: Optional[List[StationsListResponseItem]] = None
    __properties: ClassVar[List[str]] = ["id", "name", "description", "contact_name", "contact_email", "start_date", "end_date", "allocation", "location", "summary", "geometry", "stations"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCampaignResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of summary
        if self.summary:
            _dict['summary'] = self.summary.to_dict()
        # override the default output from pydantic by calling `to_dict()` of geometry
        if self.geometry:
            _dict['geometry'] = self.geometry.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in stations (list)
        _items = []
        if self.stations:
            for _item_stations in self.stations:
                if _item_stations:
                    _items.append(_item_stations.to_dict())
            _dict['stations'] = _items
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if contact_name (nullable) is None
        # and model_fields_set contains the field
        if self.contact_name is None and "contact_name" in self.model_fields_set:
            _dict['contact_name'] = None

        # set to None if contact_email (nullable) is None
        # and model_fields_set contains the field
        if self.contact_email is None and "contact_email" in self.model_fields_set:
            _dict['contact_email'] = None

        # set to None if start_date (nullable) is None
        # and model_fields_set contains the field
        if self.start_date is None and "start_date" in self.model_fields_set:
            _dict['start_date'] = None

        # set to None if end_date (nullable) is None
        # and model_fields_set contains the field
        if self.end_date is None and "end_date" in self.model_fields_set:
            _dict['end_date'] = None

        # set to None if location (nullable) is None
        # and model_fields_set contains the field
        if self.location is None and "location" in self.model_fields_set:
            _dict['location'] = None

        # set to None if geometry (nullable) is None
        # and model_fields_set contains the field
        if self.geometry is None and "geometry" in self.model_fields_set:
            _dict['geometry'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCampaignResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "contact_name": obj.get("contact_name"),
            "contact_email": obj.get("contact_email"),
            "start_date": obj.get("start_date"),
            "end_date": obj.get("end_date"),
            "allocation": obj.get("allocation"),
            "location": Location.from_dict(obj["location"]) if obj.get("location") is not None else None,
            "summary": SummaryGetCampaign.from_dict(obj["summary"]) if obj.get("summary") is not None else None,
            "geometry": GetCampaignResponseGeometry.from_dict(obj["geometry"]) if obj.get("geometry") is not None else None,
            "stations": [StationsListResponseItem.from_dict(_item) for _item in obj["stations"]] if obj.get("stations") is not None else None
        })
        return _obj


