# coding: utf-8

"""
    Upstream Sensor Storage

    Sensor Storage for Upstream data

    The version of the OpenAPI document: 0.0.1
    Contact: wmobley@tacc.utexas.edu
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from upstream_api_client.models.point import Point
from typing import Optional, Set
from typing_extensions import Self

class MeasurementItem(BaseModel):
    """
    MeasurementItem
    """ # noqa: E501
    id: StrictInt
    value: Union[StrictFloat, StrictInt]
    geometry: Point
    collectiontime: datetime
    sensorid: Optional[StrictInt] = None
    variablename: Optional[StrictStr] = None
    variabletype: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id", "value", "geometry", "collectiontime", "sensorid", "variablename", "variabletype", "description"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MeasurementItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of geometry
        if self.geometry:
            _dict['geometry'] = self.geometry.to_dict()
        # set to None if sensorid (nullable) is None
        # and model_fields_set contains the field
        if self.sensorid is None and "sensorid" in self.model_fields_set:
            _dict['sensorid'] = None

        # set to None if variablename (nullable) is None
        # and model_fields_set contains the field
        if self.variablename is None and "variablename" in self.model_fields_set:
            _dict['variablename'] = None

        # set to None if variabletype (nullable) is None
        # and model_fields_set contains the field
        if self.variabletype is None and "variabletype" in self.model_fields_set:
            _dict['variabletype'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MeasurementItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "value": obj.get("value"),
            "geometry": Point.from_dict(obj["geometry"]) if obj.get("geometry") is not None else None,
            "collectiontime": obj.get("collectiontime"),
            "sensorid": obj.get("sensorid"),
            "variablename": obj.get("variablename"),
            "variabletype": obj.get("variabletype"),
            "description": obj.get("description")
        })
        return _obj


